/****************************************************************
Message.h
CS 481 - Team A
Spring 1997
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Description: This is the message object.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _Message_h
#define _Message_h

#include "Hummer.h"      // Global hummer defines

class Message
{
public:
  char Description [NORMAL_STRING_SIZE];  // Text of the Message
  char Date[DATE_SIZE];                   // Date created
  char Time[TIME_SIZE];                   // Time created
  char Filename[NORMAL_STRING_SIZE];      // Filename message reported from
  char HostIP[IP_ADDRESS_SIZE];           // Host addres message reported from
  char Tool[NORMAL_STRING_SIZE];          // Tool that created message
  int MessageAge;       // This is used to expire messages caught in a loop.
};

#endif



