#! &PERL& -I&INCDIR&
# -*- perl -*-
#
#########################################################
#
#  Joel Marlow						
#
#  Made: 7-17-98
#  Modified: 7-17-98
#	
#  This tool will launch the other information 		
#  gathering tools.
#
#  This script was modified from the original shell script
#########################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Pg;
use Sys::Hostname;
my $host = hostname();

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || die "Can't Connect to DB\n";
my $result = $conn->exec("select * from pid");
( PGRES_TUPLES_OK eq $result->resultStatus) || die "No Tuples\n";

for ($i=0; $i < $result->ntuples; $i++) 
{
  $progid = $result->getvalue($i, 1);
  $name = $result->getvalue($i, 0);
  $isthere = 0;

  open (PS, "ps -fp $progid|") || die "Can't open pid storage file.\n";
  while (<PS>)
  {
    chop;
    @info = split(/\s+/,$_);
    if ($info[1] ne "UID")
    {
#      print "$i   $info[1]    $info[8]\n ";

# This next section is done to ensure that the pid and name match what
# is in the database for the pid

      if ($info[8] eq $name)
      {
       $isthere = 1;
#       print "YES IT MATCHES\n";
      }
      elsif ($info[8] =~ /$name/)
      {
        $isthere = 1;
#        print "YES IT MATCHES\n"; 
      }
    }
  }
  close(PS);

# if the pid is not a correct one then it will be added to a list to be deleted
# from the database

  if (!$isthere)
  {
      push (@delete, $progid);
  }


}
#print "@delete\n";
for ($i =0; $i < scalar(@delete); $i++)
{
#    print "$delete[$i]\n";
    $pidvalue = $delete[$i];
my $result = $conn->exec("delete from pid where pid = $delete[$i];");
#( PGRES_TUPLES_OK eq $result->resultStatus) || die "Could not delete value\n";
}
if (scalar(@delete))
{
  print "Done removing old pids from the database\n";
}
