#! &PERL&


##############################################################
#      current_config.cgi
#
#      Hummingbird 
#      Made: 6/29/98
#      Modified: 7/01/98
#      Joel Marlow
#      
#  This file is used to save the configuration of the current hummer. It helps
#  for stability in case postgress goes down.
##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI;
use Pg;
use strict;
use Socket;
use Sys::Hostname;

my $query = new CGI;
my $host = hostname();

my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;

print  $query->header,
    "<html><head><TITLE>Current Hummer Configuration</TITLE></head>\n
     <BODY TEXT=black BGCOLOR=white LINK=blue VLINK=purple>\n",
    "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
    "<H1>Current Hummer Configuration </H1>",
    "<HR WIDTH=\"87%\">",
    "<H4><A HREF=\"save_config.cgi\">Save Current Configuration</A></H4>",
    "<H4><A HREF=\"load_config.cgi\">Load the Saved Configuration</A></H4>";

print "<H4><A HREF=\"index.html\">Return to Hummer Homepage</A></H4>";
print "<P><HR ALIGN=CENTER WIDTH=\"51%\"><br>";
#<BR>&nbsp;
#"<H4><A HREF=\"peerinthelp.html\">Help</A></H4>", // This line needs to be moved up when help is finished for this page
#     <CENTER>\n<H2>\n

# start_form;
 
my $conn = Pg::connectdb("dbname = hummer_$host");
# $msg = $conn->errorMessage;
 ( PGRES_CONNECTION_OK eq $conn->status ) || die "Can't Connect to DB\n";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the accept_list 
#**********************************************


my $result = $conn->exec("select * from accept_list;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Accept List</FONT></B></P>";
  print "<table border=1><tr><th>Filter</th><th>Start Address</th>";
  print "<th>End Address</th><th>Inh</th></tr>\n";
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $filter = $result->getvalue($i,0);
      my $start_addr = $result->getvalue($i,1);
      my $end_addr = $result->getvalue($i,2);
      my $inh = $result->getvalue($i,3);
      print "<tr><td>$filter</td><td>$start_addr</td><td>$end_addr</td>";
      print "<td>$inh</td></tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";



#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the config_time
#**********************************************
#print TEMP "#*config_time\n";
my $result = $conn->exec("select * from config_time;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Configure Time</FONT></B></P>";
  print "<table border=1><tr><th>Ctime</th></tr>\n";
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $ctime = $result->getvalue($i,0);
      print "<tr><td>$ctime</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the filter
#**********************************************
#print TEMP "#*filter\n";

my $result = $conn->exec("select * from filter;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Filter</FONT></B></P>";
  print "<table border=1><tr><th>Expression</th><th>Date Start</th>";
  print "<th>Date End</th><th>Time Start </th><th>Time End </th>";
  print "<th>Trust </th><th>Coop </th><th>Integ </th><th>Log </th>";
  print "<th>Alert </th><th>Inh </th></tr>\n";

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $expression = $result->getvalue($i,0);
      my $date_start = $result->getvalue($i,1);
      my $date_end = $result->getvalue($i,2);
      my $time_start = $result->getvalue($i,3);
      my $time_end = $result->getvalue($i,4);
      my $trust = $result->getvalue($i,5);
      my $coop = $result->getvalue($i,6);
      my $integ = $result->getvalue($i,7);
      my $log = $result->getvalue($i,8);
      my $alert = $result->getvalue($i,9);
      my $inh = $result->getvalue($i,10);

      print "<tr><td>$expression</td><td>$date_start</td><td>$date_end</td>";
      print "<td>$time_start</td><td>$time_end</td><td>$trust</td>";
      print "<td>$coop</td><td>$integ</td><td>$log</td><td>$alert</td>";
      print "<td>$inh</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the forward_list
#**********************************************
#print TEMP "#*forward_list\n";

my $result = $conn->exec("select * from forward_list;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Forward List</FONT></B></P>";
  print "<table border=1><tr><th>Filter</th><th>Host Name</th>";
  print "<th>Host IP</th><th>Inh</th></tr>\n";
  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $filter = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $inh = $result->getvalue($i,2);
      $hosts = &getname($mem);
      print "<tr><td>$filter</td><td>$hosts</td><td>$mem</td><td>$inh</td></td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the forward_peer 
#**********************************************

#print TEMP "#*forward_peer\n";

my $result = $conn->exec("select * from forward_peer;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Forward Peers</FONT></B></P>";
  print "<table border=1><tr><th>Filter</th><th>Peer Group</th><th>Inh</th></tr>\n";
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $filter = $result->getvalue($i,0);
      my $pgroup = $result->getvalue($i,1);
      my $inh = $result->getvalue($i,2);
      print "<tr><td>$filter</td><td>$pgroup</td><td>$inh</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";
  


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the kill_file 
#**********************************************
#print TEMP "#*kill_file\n";

my $result = $conn->exec("select * from kill_file;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Kill File</FONT></B></P>";
  print "<table border=1><tr><th>Start Address</th><th>End Address</th>";
  print "<th>Inh</th></tr>\n";
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $start_addr = $result->getvalue($i,0);
      my $end_addr = $result->getvalue($i,1);
      my $inh = $result->getvalue($i,2);
      print "<tr><td>$start_addr</td><td>$end_addr</td><td>$inh</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the levels 
#**********************************************
#print TEMP "#*levels\n";

my $result = $conn->exec("select * from levels;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Levels</FONT></B></P>";
  print "<table border=1><tr><th>start_addr</th><th>end_addr</th>";
  print "<th>trust</th><th>coop</th><th>integ</th><th>inh</th></tr>\n";
  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $start_addr = $result->getvalue($i,0);
      my $end_addr = $result->getvalue($i,1);
      my $trust = $result->getvalue($i,2);
      my $coop = $result->getvalue($i,3);
      my $integ = $result->getvalue($i,4);
      my $inh = $result->getvalue($i,5);
      print "<tr><td>$start_addr</td><td>$end_addr</td><td>$trust</td>";
      print "<td>$coop</td><td>$integ</td><td>$inh</td></tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the manager 
#**********************************************
#print TEMP "#*manager\n";

my $result = $conn->exec("select * from manager;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Manager</FONT></B></P>";
  print "<table border=1><tr><th>Manager</th></tr>\n";
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $manager = $result->getvalue($i,0);
      print "<tr><td>$manager</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the peers 
#**********************************************
#print TEMP "#*peers\n";

my $result = $conn->exec("select * from peers;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Peers</FONT></B></P>";
  print "<table border=1><tr><th>Peer Group</th><th>Host Name</th>";
  print "<th>Host IP</th><th>Subscribed</th><th>Moderator</th></tr>\n";
  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $grp = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $sub = $result->getvalue($i,2);
      my $mod = $result->getvalue($i,3);
      $hosts = &getname($mem);
      print "<tr><td>$grp</td><td>$hosts</td><td>$mem</td><td>$sub</td>";
      print "<td>$mod</td></tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the pgroups 
#**********************************************
#print TEMP "#*pgroups\n";

my $result = $conn->exec("select * from pgroups;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Peer Groups</FONT></B></P>";
  print "<table border=1><tr><th>Peer Group</th><th>Host Name</th>";
  print "<th>Host IP</th><th>Email</th></tr>\n";
  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $grp = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $email = $result->getvalue($i,2);
      $hosts = &getname($mem);
      print "<tr><td>$grp</td><td>$hosts</td><td>$mem</td><td>$email</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";
  
# I COMMENTED THIS SECTION OUT BECAUSE THE PIDS DO NOT NEED TO BE SAVED
# WITH THE SAVE CONFIGURATION
#
#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the pid 
#**********************************************
#print TEMP "#*pid\n";

#my $result = $conn->exec("select * from pid;");
#(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

#  print "<P align = left><B><FONT SIZE=+3>Pids</FONT></B></P>";
#  print "<table border=1><tr><th>Name</th><th>Pid</th></tr>\n";
#  my $i;
#  for ($i=0; $i < $result->ntuples; $i++) {
#      my $name = $result->getvalue($i,0);
#      my $pid = $result->getvalue($i,1);
#      print "<tr><td>$name</td><td>$pid</td>";
#      print "</tr>\n";
#  }
#  print "</table><BR><BR>";
#  print "</td><td align=left valign=top>";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the subordinates 
#**********************************************
#print TEMP "#*subordinates\n";

my $result = $conn->exec("select * from subordinates;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  print "<P align = left><B><FONT SIZE=+3>Subordinates</FONT></B></P>";
  print "<table border=1><tr><th>Hummer Name</th><th>Subordinate</th></tr>\n";
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $hum_name = $result->getvalue($i,0);
      my $subordinate = $result->getvalue($i,1);
      print "<tr><td>$hum_name</td><td>$subordinate</td>";
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top></center>";


#end_form;



#**********************************************
#  SUBROUTINE-----getname
#
#  JM 7/1/98
#  getname gets the name of the host from the ip address
#**********************************************

sub getname {
    my($hname) = @_;

    my $n1 = index($hname,".");          
    my $s1 = substr($hname,0,$n1);                                              
    my $n2 = index($hname,".",$n1+1);
    my $s2 = substr($hname,$n1+1,$n2-($n1+1));
    my $n3 = index($hname,".",$n2+1);
    my $s3 = substr($hname,$n2+1,$n3-($n2+1));
    my $s4 = substr($hname,$n3+1);

    my @a= ($s1,$s2,$s3,$s4);
    my $addr=pack('C4',@a);

    my $names;
    my $alias;
    my $adrtype;
    my $length;
    my @address;
    ($names,$alias,$adrtype,$length,@address) = gethostbyaddr($addr,AF_INET);
    return $names;
}

