#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI qw(:standard);
use Pg;
use strict;

use Sys::Hostname;
my $host = hostname();

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || exit;
my $result;


print header;
print start_html(-title=>'Database Access Form',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple');
print "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  h1('Database Access Form'),
  "<H3><A HREF=\"dbaccesshelp.html\">Help</A></H3>",
  hr,
  "</center>";

  if (!param('Action')) {
    print "<center>",
    start_form,
    "<table border=0 cellpadding=10>",
    "<tr><td>",

#    "Date  MM-DD-YYYY<BR><BR>",
#    "Begin:<INPUT type=text name=date1 size=10>",
#    "End:<INPUT type=text name=date2 size=10><BR><BR>",
#    "Time HH:MM:SS<BR><BR>",
#    "Begin:<INPUT type=text name=time1 size=8>",
#    "End:<INPUT type=text name=time2 size=8><BR><BR>",
#    "Description<BR><BR>",
#    "<INPUT type=text name=desc size=20><BR><BR>",
    "File<BR><BR>",
    "<INPUT type=text name=filename size=20><BR><BR>",
    "Tool<BR><BR>",
    "<INPUT type=text name=tool size=20><BR><BR>",
    "Host IP<BR><BR>",
    "<INPUT type=text name=hostip size=20><BR><BR>",
    
    "Trust Level: ", popup_menu(-name=>'deftrust',
				-values=> [ 'NULL', '1', '2', '3', '4', '5' ],
			       ),

    "Cooperation Level: ", popup_menu(-name=>'defcoop',
				      -values=> [ 'NULL', '1' , '2', '3', '4', '5' ],
				     ),
    
    "Integrity Level: ", popup_menu(-name=>'definteg',
				    -values=> [ 'NULL', '1' , '2', '3', '4', '5' ],);
       
    print "</td></tr></table>",
    hr,
    submit('Action','Configure'),
    reset(),
    button(-value=>'Cancel',
	   -onclick=>"history.back()"),
    end_form,
    "</center>\n";

   print "<A HREF=\"index.html\">Return to Hummer</A>";
   print end_html;
  }

else {
    print "<center><P><B><FONT SIZE=+3>Requested Log Table Information: </FONT></B></P>";

    print "<table border=1><tr><th>Date</th><th>Time</th><th>Description</th><th>Filename</th><th>Tool</th><th>Host IP</th><th>Trust</th><th>Cooperation</th><th>Integrity</th></tr>\n";

#    my $start_date = param('date1');
#    if ($start_date eq "") { $start_date = "NULL" }
#    else { $start_date = "'$start_date'"; }
#    my $end_date = param('date2');
#    if ($end_date eq "") { $end_date = "*" }
#    else { $end_date = "'$end_date'"; }
#    my $start_time = param('time1');
#    if ($start_time eq "") { $start_time = "*" }
#    else { $start_time = "'$start_time'"; }
#    my $end_time = param('time2');
#    if ($end_time eq "") { $end_time = "*" }
#    else { $end_time = "'$end_time'"; }
#    my $desc = param('desc');
#    if ($desc eq "") { $desc = "*" }
#    else { $desc = "'$desc'"; }

    my $truststr; 
    my $coopstr; 
    my $integstr; 
    my $hostipstr; 
    my $filenamestr; 
    my $toolstr;    
    my $wherestr;
    my $isdeclared = 0;

    my $trust = param('deftrust');
    if ($trust eq "NULL") {
	$truststr = "";
    }
    else {
        $truststr = "trust = $trust";
	$isdeclared = 1;
    }


    my $coop = param('defcoop');
    if ($coop eq "NULL") {
        $coopstr = ""; 
    }
    else {
       if ($isdeclared == 1)
       {
         $coopstr = "and coop = $coop";
       }
       else
       {
         $coopstr = "coop = $coop";
         $isdeclared = 1; 
       }
    }

    my $integ = param('definteg');
    if ($integ eq "NULL") {
	$integstr = ""; 
    }
    else {
       if ($isdeclared == 1)
       {
         $integstr = "and integ = $integ";
       }
       else
       {
         $integstr = "integ = $integ";
         $isdeclared = 1; 
       }
    }

    my $hostip = param('hostip');
    if ($hostip eq "") {
	$hostipstr = ""; 
    }
    else {
       if ($isdeclared == 1)
       {
         $hostipstr = "and hostip = '$hostip'";
       }
       else
       {
         $hostipstr = "hostip = '$hostip'";
         $isdeclared = 1; 
       }
    }

    my $filename = param('filename');
    if ($filename eq "") {
	$filenamestr = ""; 
    }
    else {
       if ($isdeclared == 1)
       {
         $filenamestr = "and file = '$filename'";
       }
       else
       {
         $filenamestr = "file = '$filename'";
         $isdeclared = 1; 
       }
    } 

    my $tool = param('tool');
    if ($tool eq "") {
        $toolstr = ""; 
    }
    else {
	if ($isdeclared == 1)
	{
	    $toolstr = "and tool = '$tool'";
	}
	else
	{
	    $toolstr = "tool = '$tool'";
	    $isdeclared = 1; 
	}
    }

    if ($isdeclared ==1)
    {
	$wherestr = "where";
    }
    else {
	$wherestr = "";
    }
  
    $result = $conn->exec("select * from log $wherestr $truststr $coopstr $integstr $hostipstr $filenamestr $toolstr;");
    (PGRES_TUPLES_OK eq $result->resultStatus) || exit;

    my $i;
    for ($i=0; $i < $result->ntuples; $i++) {
        my $dbtrust = $result->getvalue($i,0);
        my $dbcoop = $result->getvalue($i,1);
        my $dbinteg = $result->getvalue($i,2);
	my $dbdate = $result->getvalue($i,3);
        my $dbtime = $result->getvalue($i,4);
        my $dbdesc = $result->getvalue($i,5);
        my $dbhostip = $result->getvalue($i,6);
        my $dbfilename = $result->getvalue($i,7);
        my $dbtool = $result->getvalue($i,8);

	print"<tr><td>$dbdate</td><td>$dbtime</td><td>$dbdesc</td><td>$dbfilename</td><td>$dbtool</td><td>$dbhostip</td><td>$dbtrust</td><td>$dbcoop</td><td>$dbinteg</td>";
	print"</tr>\n";


    }
print "</table></center><BR><BR><BR>";
print "<A HREF=\"index.html\">Return to Hummer</A>";
print end_html;
}
  



