#! &PERL&

##############################################################
#      Hummingbird  (Team A)
#      12/02/97
#      Jamie Marconi
#      
# CGI graph for the BDF tool visualization 
#
##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Graphlib;

# Set varibles at the begining
$TITLE1 = "Percentage of free disk space";
$TITLE2 = "for dworshak on $date";
$LOGPARSE = "./logparse.bdf";
$GREENLABEL = "dworshak1";
$BLUELABEL = "dworshak2";


# Make the image

title($TITLE1, $TITLE2);

# Need to do all file IO here
open(DATA, "$LOGPARSE $date|") || die "Error opening $LOGPARSE";

for ($i=0; $i<$SPD; $i++) {
    $_ = <DATA>;
    ($one, $two) = split (" ", $_);

    plot_data($one, $two, $i);
}

$high = <DATA>;
 
label_x_axis("%2.0f", $high);
	
grid;

label_y_axis;

legend($GREENLABEL, $BLUELABEL);

#print_img;
print_ht_img;

