/****************************************************************
Hummer_PG.h
CS 481 - Team E
Spring 1998
Hummingbird Project - Dr. Frincke
Coded by: Jamie Marconi
Description: This files contains the basic functions that makes a
             Database connection and Queries
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _Hummer_PG_h
#define _Hummer_PG_h

#include <libpq++.h>
#include <Hummer.h>
#include <Print_Error.h>

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/param.h>

PgDatabase *OpenDB(void);
int QueryDB(PgDatabase **PassedDB, char *query);

#endif
