
#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

package Datelib;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw($wday $month $monthday $time $isdst $year 
	     $hour $minute $second $datetime hhmmss yyyymmdd);
 


###########################################################
# Global variables
###########################################################

$localTime = `date`;
($wday,$month,$monthday,$time,$isdst,$year) = split(" ", $localTime);
($hour,$minute,$second) = split(/:/, $time);

$datetime = join(' ', $month,$monthday,$time);


###########################################################
# Remove the colons from the time stamp.  
###########################################################
sub hhmmss {
  $localTime = `date`;
  ($wday,$month,$monthday,$time,$isdst,$year) = split(" ", $localTime);
  $time =~ s/://g;
$time;
}


###########################################################
# Create date stamp with year month day.
###########################################################
sub yyyymmdd {
  $localTime = `date`;
  ($wday,$month,$monthday,$time,$isdst,$year) = split(" ", $localTime);
  $month = atoiMonth($month);
  $date = join ('', $year, $month, $monthday);
$date;
}



###########################################################
# Convert the month from alpha to numeric representation.
###########################################################
sub atoiMonth {
 local($month) = @_;
 
        $month =~ s/Jan/01/;        $month =~ s/Feb/02/;
        $month =~ s/Mar/03/;        $month =~ s/Apr/04/;
        $month =~ s/May/05/;        $month =~ s/Jun/06/;
        $month =~ s/Jul/07/;        $month =~ s/Aug/08/;
        $month =~ s/Sep/09/;        $month =~ s/Oct/10/;
        $month =~ s/Nov/11/;        $month =~ s/Dec/12/;
 $month;
}


1;
